/* Jing-Doo wang
 * jdwang@asia.edu.tw 2017.11.2
 * 
 */
package jdwang.TDCS;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeMap;

public class TDCS_M06A_RecordParser2_HashMap_6_InputDir_3_OnlyOneOutputFile
{
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		
		//String InputDir = "D:\\TDCS_Download\\201711";
		String InputDir = "D:\\TDCS_Download\\input_TDCS_24Hour_TDCS_M06A_20171030";
		/*
		 * Cteate Output Directory
		 */
		String OutputDir = "D://TDCS_Parsed";
		
		String OutputFile = OutputDir+"//"+"TDCS_GantryID_VehicleType_201711.txt";
		
		File theDir = new File(OutputDir);

		// if the directory does not exist, create it
		if (!theDir.exists()) {
		    System.out.println("creating directory: " + theDir.getName());
		    boolean result = false;

		    try{
		        theDir.mkdir();
		        result = true;
		    } 
		    catch(SecurityException se){
		        //handle it
		    }        
		    if(result) {    
		        System.out.println("DIR created");  
		    }
		}
		
		//==============================================
		
		File folder = new File(InputDir);
		
		for (final File fileEntry : folder.listFiles()) {
		        if (fileEntry.isDirectory()) {
		            //listFilesForFolder(fileEntry);
		        } else {
		            System.out.println(fileEntry.getName());
		            
		        	
		        		        	
		        	//String TestInputFile = "./TDCS_M06A_20161127_230000.csv";
		            String OneFile = fileEntry.getName();
		            String[] InputfileInfo = OneFile.split("\\.");;
		            
		            String Inputfilename =  InputfileInfo[0];
		            String TestInputFile = InputDir+"\\"+OneFile;		    		
		        	
		        	FileReader fr = new FileReader(TestInputFile);
		    		
		    		BufferedReader bfr = new BufferedReader(fr);
		    		
		    		String [] VehicleTypes = {"5","31","32","41","42"};
		    		/*
		    		 * Create a HashMap for storing the number of each type of vehicles
		    		 */
		    		//HashMap  <String, Integer> VehicleTypeCnt  = new HashMap <String, Integer> ();		
		    		TreeMap  <String, Integer> VehicleTypeCnt  = new TreeMap <String, Integer> ();		
		    		
		    		for (int i=0;i<VehicleTypes.length;++i)
		    		{
		    			VehicleTypeCnt.put(VehicleTypes[i],0);
		    		} 		
		    		
		    		String OneLine;
		    		int cnt =0;
		    		while ((OneLine=bfr.readLine()) != null)
		    		{
		    			//System.out.println(OneLine);
		    			
		    			cnt++;			
		    			String [] Items = OneLine.split(",");
		    			
		    			int temp = VehicleTypeCnt.get(Items[0]); // 31
		    			temp++;
		    			VehicleTypeCnt.put(Items[0], temp);				
		    		}	
		    		System.out.println(TestInputFile+" Total Records: "+cnt);
		    		
		    		//String OutputFile = "VehicleTypeCnt_OneLine_FieldName_Sorted.csv";
		    		//String OutputFile = OutputDir+"//"+Inputfilename+"_VehicleTypeCnt_OneLine_FieldName_Sorted.csv";	    		
		    		//System.out.println("OutputFile=>"+OutputFile);
		    		
		    		FileWriter fw;
		    		BufferedWriter bfw = null;
		    		
		    		File f = new File(OutputFile);
		    		if (!f.exists()) {
			    		System.out.println("Create New OutputFile=>"+OutputFile);
			    		fw = new FileWriter(OutputFile);
			    		bfw = new BufferedWriter(fw);
			    		/*
			    		 * Output FieldName
			    		 */
			    		bfw.write("VehicleType"+ ",");
			    		for (Object key : VehicleTypeCnt.keySet()) {			 
			    			bfw.write(key + ",");            
			            }
			    		bfw.newLine();
		    		} else {
		    			System.out.println("Append to OutputFile=>"+OutputFile);
			    		fw = new FileWriter(OutputFile, true);
			    		bfw = new BufferedWriter(fw);
		    		}
		    		
		    		/*
		    		 * Output the values
		    		 */ 
		    		//bfw.write("Frequency"+ ",");
		    		bfw.write(OneFile+ ",");
		    		for (Object key : VehicleTypeCnt.keySet()) {
		                System.out.println(key + " : " + VehicleTypeCnt.get(key));
		                bfw.write(VehicleTypeCnt.get(key)+ ",");          
		            }
		    		bfw.newLine();
		    		bfw.flush();
		    		fw.close();
	    		
		        } // End of if (fileEntry.isDirectory()) {
		} // End of for (final File fileEntry : folder.listFiles())
	} // End of public static void main(String[] args) throws IOException {	
} // End of public class TDCS_M06A_RecordParser2_HashMap_6_InputDir_1_ReadDir
